package tical.ui.graphical;

import java.awt.Dimension;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.BoxLayout;

import tical.ui.graphical.panel.Panel_StepLoader;

public class Dialog_Loader extends JDialog
{
	private JProgressBar _jProgressBar;
	private Panel_StepLoader _step[];
	private int _curStep;
	private int _nbrStep;
	private JPanel _jContentPane;

	public Dialog_Loader(String title)
	{
		this(title, -99, null);
	}

	public Dialog_Loader(String[] strStep)
	{
		this(null, -99, strStep);
	}

	public Dialog_Loader(String title, int nbrStep, String[] strStep)
	{
		super();
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.setTitle(title);
		this.setMinimumSize(new Dimension(310,115));
		this._nbrStep = nbrStep;
		this._curStep = 0;
		this._jContentPane = new JPanel();
		this._jContentPane.setLayout(new BoxLayout(this._jContentPane, BoxLayout.Y_AXIS));
		this.setContentPane(this._jContentPane);
		this._jProgressBar = new JProgressBar();
		this._jContentPane.add(this._jProgressBar, 0);
		if (nbrStep > 0 && strStep != null)
			this.setStep(nbrStep, strStep);
	}

	public void setStep(int nbrStep, String[] strStep)
	{
		this.setVisible(false);
		this._step = new Panel_StepLoader[ nbrStep ];
		for(int i = 0; i < nbrStep; i++)
		{
			this._step[ i ] = new Panel_StepLoader(strStep[ i ], Panel_StepLoader.STATUS_ONROAD);
			this._jContentPane.add(this._step[ i ], i + 1);
		}
		this._setJProgressBar();
		this.pack();
		for(int i = 1; i < nbrStep; i++)
			this._step[ i ].setStatus(Panel_StepLoader.STATUS_NOTLAUNCH);
	}

	public boolean updateProgress()
	{
		System.out.println(this._curStep + " > " + (this._curStep + 1));
		this._step[ this._curStep ].setStatus(Panel_StepLoader.STATUS_FINISH);
		//augmente la barre
		this._jProgressBar.setValue(++this._curStep);
		//rends visible les champs Jlabel
		if (this._curStep < this._nbrStep)
			this._step[ this._curStep ].setStatus(Panel_StepLoader.STATUS_ONROAD);
		else
			this._jProgressBar.setIndeterminate(false);
		return true;
	}

	private void _setJProgressBar()
	{
		this._jProgressBar.setMaximum(this._nbrStep);
		this._jProgressBar.setValue(this._curStep);
		this._jProgressBar.setStringPainted(true);
		this._jProgressBar.setIndeterminate(true);
		this._step[0].setStatus(Panel_StepLoader.STATUS_ONROAD);
	}
}
