package tical.ui.graphical.frame;

import java.util.Calendar;

import javax.swing.GroupLayout;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.text.BadLocationException;

import tical.main.Controller;
import tical.ui.graphical.controls.button.Button_Annuler;
import tical.ui.graphical.controls.button.Button_Valider;
import tical.ui.graphical.controls.txtZone.TxtArea_EventDescription;
import tical.ui.graphical.controls.txtZone.Txt_Date;
import tical.ui.graphical.controls.txtZone.Txt_Time;
import tical.ui.graphical.panel.Panel_Calendar;
import tical.utils.ValidateListener;
import tical.utils.calendar.CalEvent;
import tical.utils.calendar.CalEvents;

/**
 * @author   grummfy
 * @version 28-02-2008
 */
public class Frame_Event extends JFrame implements ValidateListener
{
	private Txt_Date DateEnd;
	private Txt_Date DateStart;
	private TxtArea_EventDescription Description;
	private Txt_Time TimeEnd;
	private Txt_Time TimeStart;
	private JTextField Titre;
	private Button_Valider jButton1;
	private Button_Annuler jButton2;
	private Panel_Calendar pCal;

	private final Controller controller;

	public Frame_Event(final Controller controller)
	{
		super("Ajout d'un event");

		this.controller = controller;

		this.setMinimumSize(new java.awt.Dimension(565, 335));
		Description = new TxtArea_EventDescription();
		Titre = new JTextField();
		jButton1 = new Button_Valider(this);
		jButton2 = new Button_Annuler(this);
		jButton1.addValidateListener(this);
		TimeStart = new Txt_Time("00:00");
		TimeEnd = new Txt_Time("00:00");
		Calendar now = Calendar.getInstance();
		String dateNow = now.get(Calendar.DATE) + "/" + now.get(Calendar.MONTH) + "/" + now.get(Calendar.YEAR);
		now = null;
		DateStart = new Txt_Date(dateNow);
		DateEnd = new Txt_Date(dateNow);

		this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		// javax.swing.WindowConstants.EXIT_ON_CLOSE);

		this.pCal = new Panel_Calendar(this.controller);

		Titre.setText("Le titre de mon event");

		this._mkFrame();
		pack();
		this.setVisible(false);
	}

	public void validationPerformed()
	{
		CalEvent ce = new CalEvent();
		ce.setDescription(this.Description.getText());
		ce.setText(this.Titre.getText());
		try
		{
			ce.setTime(this.DateStart.getDate() + 'T' + this.TimeStart.getTime() + "+01:00",
					this.DateEnd.getDate() + 'T' + this.TimeEnd.getTime() + "+01:00");
			//2006-04-17T15:00:00-08:00
		}
		catch (BadLocationException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.exit(-99);
		}

		CalEvents ces = new CalEvents(this.controller);
		String[] calId = this.pCal.getSelected();
		for (int i = 0; i < calId.length && calId[ i ] != null; i++)
			ces.Add(calId[ i ], ce);
		System.out.println("Évènement ajouté!");
	}

	/**
	 * Nécéssite la version 1.6 de java -> grouplayout!
	 *
	 */
	private void _mkFrame()
	{
		JLabel jLabel1 = new JLabel("Date");
		JLabel jLabel2 = new JLabel("Heure");
		JLabel jLabel3 = new JLabel("Titre");
		JLabel jLabel4 = new JLabel("Description");

		GroupLayout layout = new GroupLayout(getContentPane());
		layout.setAutoCreateGaps(true);
		//positionnement des élements ... ne plus essayer de comprendre cela casse la tête!

		/**
		 * @TODO refaire les différents panel dans un joli style et surtout avec image et une logique ...
		 */

		layout.setHorizontalGroup(
			layout
			.createParallelGroup(GroupLayout.Alignment.LEADING)
			.addGroup(GroupLayout.Alignment.TRAILING,
				layout.createSequentialGroup()
				.addGroup(
					layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
						.addGroup(
							layout.createSequentialGroup()
							.addGroup(
								layout.createParallelGroup(GroupLayout.Alignment.LEADING)
								.addComponent(jLabel4)
								.addGroup(GroupLayout.Alignment.TRAILING,
									layout.createSequentialGroup()
									.addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
										.addComponent(jLabel3)
										.addComponent(jLabel2))
											.addPreferredGap(ComponentPlacement.RELATED)
												.addGroup(
													layout.createParallelGroup(GroupLayout.Alignment.LEADING)
														.addComponent(this.Titre, GroupLayout.DEFAULT_SIZE, 205, Short.MAX_VALUE)
															.addGroup(
																layout.createSequentialGroup()
																	.addComponent(this.TimeStart, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
																		.addPreferredGap(ComponentPlacement.RELATED, 120, Short.MAX_VALUE)
																	.addComponent(this.TimeEnd, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
															)
															.addGroup(GroupLayout.Alignment.TRAILING,
																layout.createSequentialGroup()
																	.addComponent(this.DateStart, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
																		.addPreferredGap(ComponentPlacement.RELATED, 40, Short.MAX_VALUE)
																	.addComponent(this.DateEnd, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
															)
												)
								)
								.addComponent(jLabel1)
								.addComponent(this.Description, GroupLayout.PREFERRED_SIZE, 250, GroupLayout.PREFERRED_SIZE)
							)
							.addGap(15, 15, 15)
								.addComponent(this.pCal, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						)
						.addGroup(
							layout.createSequentialGroup()
								.addComponent(jButton2)
									.addPreferredGap(ComponentPlacement.RELATED)
										.addComponent(jButton1)
						)
				)
				.addContainerGap()
			)
		);

		layout.setVerticalGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
			.addGroup(layout.createSequentialGroup().addContainerGap()
				.addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
					.addGroup(layout.createSequentialGroup()
						.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
							.addComponent(jLabel1)
							.addComponent(this.DateStart, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							.addComponent(this.DateEnd, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						)
						.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(
								layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
									.addComponent(jLabel2)
									.addComponent(this.TimeStart, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
									.addComponent(this.TimeEnd, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							)
							.addGap(10, 10, 10)
								.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
									.addComponent(jLabel3).addComponent(this.Titre, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
								)
								.addPreferredGap(ComponentPlacement.RELATED)
								.addComponent(jLabel4).addGap(10, 10, 10)
								.addComponent(this.Description, GroupLayout.DEFAULT_SIZE, 145, Short.MAX_VALUE)
					)
					.addComponent(this.pCal, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
				)
				.addPreferredGap(ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
				.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
					.addComponent(jButton1)
					.addComponent(jButton2))
					.addContainerGap()
			)
		);

		this.getContentPane().setLayout(layout);
	}
}
