package tical.ui.graphical.frame;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.JFrame;

import tical.main.Controller;
import tical.ui.graphical.controls.menu.MenuBar;
import tical.ui.graphical.controls.menu.ToolBar;
import tical.ui.graphical.panel.Main_Panel_Application;
import tical.ui.graphical.panel.Main_Panel_Auth;
import tical.ui.graphical.panel.Main_Panel_Calendrier;
import tical.ui.graphical.panel.Main_Panel_Event;

/**
 * @author   grummfy
 * @version 19-08-2008
 */
public class Frame_Main extends JFrame
{
	private Main_Panel_Application _mpApp;
	private Main_Panel_Event _mpEvent;
	private Main_Panel_Calendrier _mpCal;
	private Main_Panel_Auth _mpAuth;

	public Frame_Main(final Controller controller)
	{
		super("TiHenamCalendar");
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		this.setLayout(new GridLayout(2,2));

		this._mpApp = new Main_Panel_Application(controller);
		this._mpCal = new Main_Panel_Calendrier(controller);
		this._mpEvent = new Main_Panel_Event(controller);
		this._mpAuth = new Main_Panel_Auth(controller);

		this.add(this._mpEvent);
		this.add(this._mpCal);
		this.add(this._mpAuth);
		this.add(this._mpApp);

		this.setMinimumSize(new Dimension(420, 240));
		this.pack();
		this.setVisible(false);
	}
/*
	public Frame_Main(final Controller controller)
	{
		super("Test");
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		this.setJMenuBar(new MenuBar());
		this.getContentPane().add(new ToolBar(controller), BorderLayout.PAGE_START);
		this.pack();
		this.setSize(640, 480);
		this.setVisible(false);
	}
*/
}
