package tical.ui.graphical.panel;

import java.awt.GridLayout;

import javax.swing.JPanel;

import tical.main.Controller;
import tical.ui.graphical.controls.CheckBox_Calendrier;
import tical.ui.graphical.controls.JListCalendar;
import tical.utils.calendar.Cal;
import tical.utils.calendar.Cals;

/**
 * @author   grummfy
 * @version 28-02-2008
 */
public class Panel_Calendar extends JPanel
{
	private CheckBox_Calendrier _cbCal[];
	private JListCalendar _lCal;
	private final Controller _controller;
	public static final int CAL_TYPE_CHECKBOX = 1;
	public static final int CAL_TYPE_LISTBOX = 2;
	private int _CAL_TYPE;

	public Panel_Calendar(final Controller controller, int calType)
	{
		super();
		this._controller = controller;
		this._CAL_TYPE = calType;
		this.setBorder(javax.swing.BorderFactory.createTitledBorder("Calendrier"));
		this.setAutoscrolls(true);
		
		this.addCalendar();
	}

	public Panel_Calendar(final Controller controller)
	{
		this(controller, CAL_TYPE_LISTBOX);
	}

	public void addCalendar()
	{
		switch (this._CAL_TYPE)
		{
			case CAL_TYPE_CHECKBOX:
				this._addCalendar1();
				break;
			case CAL_TYPE_LISTBOX:
			default:
				this._addCalendar2();
		}
	}

	/**
	 * Ajout de la liste de calendrier dans une listebox 
	 *
	 */
	private void _addCalendar2()
	{
		Cals cals = new Cals(this._controller);
		Cal myCal[] = cals.getCalList();
		this._lCal = new JListCalendar();
		for (int i = 0; i < myCal.length; i++)
			this._lCal.addElement(myCal[ i ].getName());
		this.add(this._lCal);
	}

	/**
	 * Ajout de la liste de calendrier dans des checkboxs
	 *
	 */
	private void _addCalendar1()
	{
		Cals cals = new Cals(this._controller);
		Cal myCal[] = cals.getCalList();
		this._cbCal = new CheckBox_Calendrier[ myCal.length ];
		this.setLayout(new GridLayout((int)(Math.floor((myCal.length / 2.0) + 0.5d)), 2));
		for (int i = 0; i < myCal.length; i++)
		{
			this._cbCal[ i ] = new CheckBox_Calendrier(myCal[ i ].getName(), myCal[ i ].getId());
			this.add(this._cbCal[ i ]);
		}
		this._lCal = new JListCalendar();
		this.add(this._lCal);
	}

	/**
	 * Renvoi la liste des calendrier sélectionner
	 * @return id du calendrier
	 */
	public String[] getSelected()
	{
		switch (this._CAL_TYPE)
		{
			case CAL_TYPE_CHECKBOX:
				this._getChecked();
				break;
			case CAL_TYPE_LISTBOX:
			default:
				this._getSelected();
		}
		return null;
	}

	private String[] _getSelected()
	{
		int selectedCal[] = this._lCal.getSelected();
		String selCal[] = new String[ selectedCal.length ];
		Cals cals = new Cals(this._controller);
		Cal myCal[] = cals.getCalList();
		cals = null;

		for(int i = 0; i < selectedCal.length; i++)
			selCal[ i ] = myCal[ selectedCal[i] - 1 ].getId();//-1 car décallage à cause du 0 pour aucun calendrier ..

		return selCal;
	}

	private String[] _getChecked()
	{
		String cbxCal[] = new String[ this._cbCal.length ];
		int j = 0;
		for(int i = 0; i < cbxCal.length; i++)
		{
			if (this._cbCal[ i ].isSelected())
				cbxCal[ j++ ] = this._cbCal[ i ].getValue();
		}
		return cbxCal;
	}
}
