package tical.ui.graphical.panel;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class Panel_StepLoader extends JPanel
{
	private JLabel _label;
	private JLabel _labelStatus;
	private short _status;

	public final static short STATUS_FINISH = 3;
	public final static short STATUS_ONROAD = 2;
	public final static short STATUS_NOTLAUNCH = 1;

	public Panel_StepLoader()
	{
		this(null, STATUS_NOTLAUNCH);
	}

	public Panel_StepLoader(String txt)
	{
		this(txt, STATUS_NOTLAUNCH);
	}

	public Panel_StepLoader(short status)
	{
		this(null, status);
	}

	public Panel_StepLoader(String txt, short status)
	{
		this.setLayout(new BoxLayout(this, BoxLayout.X_AXIS));

		this._label = new JLabel(txt);
		this.add(this._label, 0);

		this._labelStatus = new JLabel();
		this.add(this._labelStatus, 1);

		this.setStatus(status);
	}

	public void setText(String text)
	{
		this._label.setText(text);
	}

	public String getText()
	{
		return this._label.getText();
	}

	public void setStatus(short status)
	{
		this._status = status;
		switch (status)
		{
			case STATUS_NOTLAUNCH:
				this._labelStatus.setText(" ");
				this.setVisible(false);
				break;
			case STATUS_ONROAD:
				this._labelStatus.setText(" ...");
				this.setVisible(true);
				break;
			case STATUS_FINISH:
				this._labelStatus.setText(" OK");
				this.setVisible(true);
				break;
		}
	}

	public short getStatus()
	{
		return this._status;
	}
}
