package tical.utils;

import java.io.FileReader;
import java.util.Hashtable;

import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;


/**
 * @author  grummfy
 * @version 23-02-2008
 */
public class Config
{
	private Hashtable data;
	private ConfigDataAuth auth;
	private ConfigDataAbout app;

	public Config()
	{
		this.app = new ConfigDataAbout();
		this.auth = new ConfigDataAuth();
		this.data = new Hashtable();
		this.load();
	}

	public boolean isGraphical()
	{
		return (this.data.get("gui")).equals("1");
	}

	public String googleServiceName()
	{
		return this.app.companyName + "-" + this.app.appName + "-" + this.app.version;
	}

	public String getLogin()
	{
		return this.auth.login;
	}

	public String getPassword()
	{
		return this.auth.password;
	}

	public Object get(String key)
	{
		return this.data.get(key);
	}

	private void load()
	{
		XMLReader xr;
		try
		{
			xr = XMLReaderFactory.createXMLReader();
			ConfigReader handler = new ConfigReader(this.data, this.auth, this.app);
			xr.setContentHandler(handler);
			xr.setErrorHandler(handler);
			xr.parse(new InputSource(new FileReader("./.config.xml")));
		}/*
		catch (SAXException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (FileNotFoundException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/
		catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.exit(1);
		}
	}
}

abstract class ConfigData
{
}

class ConfigDataAuth extends ConfigData
{
	protected String login;
	protected String password;
}

class ConfigDataAbout extends ConfigData
{
	protected String version;
	protected String appName;
	protected String companyName;
}

class ConfigWriter
{
	// TODO écriture -> gnu.java.....nodewriter?
}

class ConfigReader extends DefaultHandler
{
	private Hashtable data;
	private ConfigDataAbout cda;
	private ConfigDataAuth cdl;
	private char chout[];
	private String attrName;

	public ConfigReader(Hashtable data, ConfigDataAuth cdl, ConfigDataAbout cda)
	{
		super();
		this.data = data;
		this.cda = cda;
		this.cdl = cdl;
	}

	// //////////////////////////////////////////////////////////////////
	// Event handlers.
	// //////////////////////////////////////////////////////////////////
	public void startElement(String uri, String name, String qName, Attributes attributes)
	{
		//System.out.println(name + '-' + qName);
		/*if(qName.equals("preferences"))
		{
			//new preferences
		}
		else */if(qName.equals("preference"))
		{
			//this.data.put(attributes.getValue("name"), this.chout);
			this.attrName = attributes.getValue("name");
		}
		else if(qName.equals("auth"))
		{
			this.cdl.login = attributes.getValue("login");
			this.cdl.password = attributes.getValue("password");
		}
		else if(qName.equals("about"))
		{
			this.cda.appName = attributes.getValue("appName");
			this.cda.companyName = attributes.getValue("companyName");
			this.cda.version = attributes.getValue("version");
		}
	}

	public void endElement(String uri, String name, String qName)
	{
		/*if(qName.equals("preferences"))
		{
			//end preferences
		}*/
		if(qName.equals("preference"))
		{
			this.data.put(this.attrName, new String(this.chout));
		}
	}

	public void characters(char ch[], int start, int length)
	{
		int lng = length;
		this.chout = new char[ lng ];

		for (int i = 0; i < lng; i++)
		{
			this.chout[ i ] = ch[ start + i ];
		}
	}
}