package tical.utils;

import tical.ui.graphical.Dialog_Loader;

public class Loader
{
	private int _nbrStep;
	private int _curStep;
	private String[] _strStep;
	private Dialog_Loader _dl;

	public Loader()
	{
		this(null, null);
	}

	public Loader(String Title)
	{
		this(Title, null);
	}

	public Loader(String[] step)
	{
		this(null, step);
	}

	public Loader(String title, String[] step)
	{
		this._nbrStep = step.length;
		this._curStep = 0;
		this._strStep = (String[])step.clone();
		this._dl = new Dialog_Loader(((title != null)?title:"Chargement..."), this._nbrStep, this._strStep);
	}

	public void setStep(String[] step)
	{
		this._strStep = (String[])step.clone();
		this._nbrStep = step.length;
		this._dl.setStep(this._nbrStep, this._strStep);
	}

	public void setCurStep(int step)
	{
		this._curStep = step--;
		try
		{
			this.nextStep();
		}
		catch (Exception e)
		{
			e.printStackTrace();
			System.exit(-99);
		}
	}

	public void nextStep() throws Exception
	{
		this._curStep++;
		if (this._curStep > this._strStep.length || !this._dl.updateProgress())
			throw new Exception("Erreur de dépassement : le nombre d'étapes est dépassé!");
	}

	public void close()
	{
		synchronized (this)
		{
			try
			{
				this.wait(250);
			}
			catch (InterruptedException e)
			{
				// TODO Bloc catch auto-généré
				e.printStackTrace();
			}
		}
		this._dl.dispose();
	}

	public void start()
	{
		this._dl.setVisible(true);
	}
}
