package tical.utils.calendar;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Iterator;

import tical.main.Controller;
import tical.utils.Loader;

import com.google.gdata.client.calendar.CalendarService;
import com.google.gdata.data.calendar.CalendarEntry;
import com.google.gdata.data.calendar.CalendarFeed;
import com.google.gdata.util.ServiceException;

/**
 * @author   grummfy
 * @version 28-02-008
 */
public class Cals
{
	private final Controller controller;

	protected static Cal myCal[];

	public Cals(final Controller controller)
	{
		this.controller = controller;
		if (myCal == null || myCal.length == 0)
			this._Updatelist();
			//this._Test();
	}

	public Cal[] getCalList()
	{
		return myCal;
	} 

	private void _Test()
	{
		Cal myCal2[] = {new Cal("tihenam%40gmail.com", "Ti Common", "A32929"),
			new Cal("qrvch65ihlqh9n9kfek097tc0s%40group.calendar.google.com", "1", "1B887A"),
			new Cal("f70enksqu0v4sdfq5u4spgpsoo%40group.calendar.google.com", "1 - A", "29527A"),
			new Cal("dse53tsa02vleihjgkgllka7go%40group.calendar.google.com", "1 - B", "2952A3"),
			new Cal("mh7eevqhgu9d48r8brhdr7fku4%40group.calendar.google.com", "1 - C", "28754E"),
			new Cal("ntcb33i7ognhar112r5e675a80%40group.calendar.google.com", "1 - D", "528800"),
			new Cal("ql355qu7d3kebhrdp711qvg10c%40group.calendar.google.com", "1 - E1", "0D7813"),
			new Cal("8r8dptqc4ckbbet1vdhlgend5k%40group.calendar.google.com", "1 - E2", "88880E"),
			new Cal("b860cag9ibfohuhhj23tjevqk8%40group.calendar.google.com", "1 - F", "AB8B00"),
			new Cal("ok69odpt5j8v1cnrcbfgh7gitg%40group.calendar.google.com", "1 - G", "BE6D00"),
			new Cal("pviukca8uk9fpfo9gc30nmoikg%40group.calendar.google.com", "1 - H1", "B1440E"),
			new Cal("hd5s28of9ut1loj1cut4qll068%40group.calendar.google.com", "1 - H2", "B1365F"),
			new Cal("goutqmlfaouh99tal7cbea1g18%40group.calendar.google.com", "1 - I", "7A367A"),
			new Cal("ch3g7h3up4iok0smdjrj1mfji8%40group.calendar.google.com", "2", "865A5A"),
			new Cal("vp4582h2dq45oflkf3hdntb7l8%40group.calendar.google.com", "2 - A", "705770"),
			new Cal("6j1otr9f9ipl0o97qunmtu93o4%40group.calendar.google.com", "2 - B1", "4A716C"),
			new Cal("cm9vf6emru4eskcjep9bq5ol38%40group.calendar.google.com", "2 - B2", "4E5D6C"),
			new Cal("o9fbj2df99rtmskqefa3ieufvg%40group.calendar.google.com", "2 - C", "5A6986"),
			new Cal("hbj1pnpch6ouu8f50j8k78l9sc%40group.calendar.google.com", "Sortie", "99CC33")
		};
		myCal = myCal2;
	}

	private void _Updatelist()
	{
		String[] step = {"Connexion au service Google Calendar", "Rapatriement des données"};
		Loader l = new Loader(step);
		l.start();

		CalendarService cs = this.controller.getService().Auth();
		URL feedUrl;
		try
		{
			l.nextStep();

			feedUrl = new URL("https://www.google.com/calendar/feeds/default/owncalendars/full");
			//System.out.println(feedUrl);
			CalendarFeed resultFeed = (CalendarFeed) cs.getFeed(feedUrl, CalendarFeed.class);
			Iterator ite = resultFeed.getEntries().iterator();
			myCal = new Cal[ resultFeed.getEntries().size() ];
			int i = 0;

			while(ite.hasNext())
				myCal[i++] = new Cal((CalendarEntry)ite.next());

			l.nextStep();
			l.close();
		}
		catch (MalformedURLException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (ServiceException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch (Exception e)
		{
			// TODO Bloc catch auto-généré
			e.printStackTrace();
		}
	}
}
