package tuto;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.EventObject;

import javax.swing.JButton;

public class SpcButton extends JButton implements MouseListener
{
	public static final int BUTTON_ANNULER = 1;
	public static final int BUTTON_VALIDER = 2;
	protected int _type;

	public SpcButton(int type)
	{
		super();
		this.addMouseListener(this);
		this._type = type;
		switch(this._type)
		{
			case BUTTON_VALIDER:
				this.setText("Valider");
				break;
			case BUTTON_ANNULER:
			default:
				this.setText("Annuler");
		}
	}

	public void addButtonListener(ButtonListener vl)
	{
		//On utilise la liste de listener présent dans javax.swing.JComponent
		listenerList.add(ButtonListener.class, vl);
	}

	public void removeValidateListener(ButtonListener vl)
	{
		this.listenerList.remove(ButtonListener.class, vl);
	}

	protected synchronized void _fireButtonPerformed()
	{
		switch(this._type)
		{
			case BUTTON_VALIDER:
				this._fireValide();
				break;
			case BUTTON_ANNULER:
			default:
				this._fireCancel();
		}
	}

	protected synchronized void _fireCancel()
	{
		ButtonListener clist[] = (ButtonListener[]) this.getListeners(ButtonListener.class);
		for (int i = (clist.length - 1); i >= 0; i--)
			clist[ i ].cancelPerformed();
	}

	protected synchronized void _fireValide()
	{
		ButtonListener clist[] = (ButtonListener[]) this.getListeners(ButtonListener.class);
		for (int i = (clist.length - 1); i >= 0; i--)
			clist[ i ].validePerformed();
	}

	public void mouseClicked(MouseEvent e)
	{
		this._fireButtonPerformed();
	}

	public void mouseEntered(MouseEvent e)
	{}

	public void mouseExited(MouseEvent e)
	{}

	public void mousePressed(MouseEvent e)
	{}

	public void mouseReleased(MouseEvent e)
	{}
}